#Standalone installation
##Web server Requirements
1. `yum install nginx`
2. `service nginx start`


## Database Requirements
1. Postgresql 11 and above
	yum -y install https://download.postgresql.org/pub/repos/yum/reporpms/EL-7-x86_64/pgdg-redhat-repo-latest.noarch.rpm
	yum -y install postgresql11-server postgresql11-contrib prefix11 ip4r11
	/usr/pgsql-11/bin/postgresql11-setup initdb
2. adduser -c -s webbackend
 
## Python Requirements
1. Python >= 3.6
2. PIP => 9.0.1
3. install falcon_rest from git:
    git clone http://stash.denovolab.com/scm/af/falcon_rest.git
    cd falcon_rest 
    python3 setup.py install
4. see requirements.txt

##installation steps
git clone 

1. cd to any temporary writable dir and get tarball from git:
1. `git archive --remote=http://stash.denovolab.com/scm/clas6/webbackend.git HEAD:dist api-dnl-head.tar.gz | tar -x` 
2. `pip install --upgrade api-dnl-head.tar.gz`
3. all needed data files wil be installed to /opt/denovolab_v6/api_dnl
4. `cd /opt/denovolab_v6/api_dnl`
5.  create database class4_dnl
6.  create database user webbackend
7.  psql -U webbackend -d class4_dnl < schema/schema.sql`
8. `psql -U webbackend -d class4_dnl < schema/class4_update_record.sql`
9. `psql -U webbackend -d class4_dnl < schema/data.sql`
10. change api.ini api_host must be external ip address or dns name of api
11. api_schema depend of nginx "http" ot "https" configuration
12. installation will create following entry points for api_dnl:
 
    `/usr/local/bin/api_dnl_run`  <-- run gunicorn web service
    `/usr/local/bin/api_dnl_pcaploader` <-- exec pcap loader 
    `/usr/local/bin/api_dnl_pjsipcall` <-- exec test call service
    `/usr/local/bin/api_dnl_ws_broker` <-- exec web socket callback service
    `/usr/local/bin/api_dnl_worker` <-- exec celery run task service
    `/usr/local/bin/api_dnl_beat` <-- exec celery schedule task service
 
##standalone upgrade version method
1. `git archive --remote=ssh://git@stash.denovolab.com:7999/clas6/webbackend.git HEAD:dist api-dnl-head.tar.gz | tar -x` 
2. `pip install --upgrade builds/api-dnl-head.tar.gz`
3. `cd /opt/denovolab_v6/api_dnl`
#### Update database #########
4. `sudo /usr/local/bin/alembic upgrade head`
 
##pjsua installation (needed for api_dnl_pjsipcall)
`sudo apt-get update`

`sudo apt-get -y install build-essential python-dev libpjsua2 libssl-dev libasound2-dev`

`wget http://www.pjsip.org/release/2.7.1/pjproject-2.7.1.tar.bz2`

`tar -xf pjproject-2.7.1.tar.bz2 && cd pjproject-2.7.1/`
`export CFLAGS="$CFLAGS -fPIC"`

`./configure --enable-shared --disable-video --disable-ffmpeg --disable-v4l2 --disable-libwebrtc`
`./configure && make dep && make`
`cd pjsip-apps/src/`
`git clone https://github.com/mgwilliams/python3-pjsip.git`
`cd python3-pjsip`
`sudo python3 setup.py install`

##wsocket libs (needed for api_dnl_ws_broker)
`pip install git+https://github.com/dpallot/simple-websocket-server.git`

`pip install websocket-client`
 